module Ubc.Parse.Syntax.Expression
where

import Text.Parsec (ParsecT)
import Ubc.Parse.Syntax.Operators (BinaryOperator, UnaryOperator)
import {-# SOURCE #-} Ubc.Parse.Syntax.Statement (Statement)

data Expression = Binary BinaryOperator Expression Expression
        | Unary UnaryOperator Expression
        | ConstantInteger Integer
        | ConstantFraction Rational
        | FunctionCall String [Expression]
        | Variable String
        | If Expression Expression (Maybe Expression) -- if then else
        | Loop Expression Expression -- condition body
        | Block [Statement]
instance Show Expression
expressionParser :: Monad m => ParsecT String u m Expression
