module Ubc.Parse.Syntax.TypeExpression
( TypeExpression(..)
, parseTypeExpression
)
where

import Control.Monad ((<$!>))

import Text.Parsec (choice, ParsecT)

import Ubc.Parse.Syntax.VariableType (VariableType)
import Ubc.Parse.Syntax.Struct (Struct)

import qualified Ubc.Parse.Syntax.Language as UbcLanguage
import qualified Ubc.Parse.Syntax.VariableType as VariableType
import qualified Ubc.Parse.Syntax.Struct as Struct

data TypeExpression = TypeAlias VariableType
        | StructExpression Struct
        deriving (Show)


parseTypeExpression :: Monad m => ParsecT String u m TypeExpression
parseTypeExpression = choice
                        [ TypeAlias . VariableType.fromString <$!> UbcLanguage.typeName
                        , StructExpression <$!> Struct.parse
                        ]
